#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <stdbool.h>

#define TAILLE_MAX 10


void
afficherTableau(int t[], int n){
  for(int i = 0 ; i < n ; i++){
    printf("%d ", t[i]);
  }
  printf("\n");
}

int minimum(int t[], int n)
{
    int m=t[0];
    for (int i=1; i<n ; i++){
        if ( t[i]<m )
            m=t[i];
    }
    return m ;
}

bool appartient(int x, int t[], int n)
{
    for(int i=0; i<n; i++)
    {
        if(t[i]==x)
        {
            return true;
        }
    }
    return false;
}

void doubler(int t[], int n)
{
    for(int i=0; i<n; i++)
    {
        t[i]*=2;
    }
}

void cumuler(int t[], int n)
{
    for(int i=1; i<n; i++)
    {
        t[i]= t[i]+t[i-1]; /* à ce moment là, t[i-1] contient
                              la somme des cases 0,...,i-1 du tableau initial */
    }
}

void renverser(int t[], int n)
{
    int tmp;
    for(int i=0; i<n/2; i++)/* on échange les valeurs des cases 0 et n-1,
                               puis 2 et n-2, ect, jusqu'à arriver au milieu. */
    {
        tmp = t[i];
        t[i] = t[n-i-1];
        t[n-i-1] = tmp;
    }
}

int
main(int argc, char *argv[]){
  assert(argc >= 2); 
  int t[TAILLE_MAX];    /* declaration du tableau */
  int n = argc - 1;   /* nombre d'entiers sur la ligne de commande */
  assert(n <= TAILLE_MAX); 
  for( int i = 0 ; i < n ; i++){
    t[i] = atoi(argv[i+1]);   /* conversion en entier */
  } 
 
  printf("Le tableau contient : \n");
  afficherTableau(t, n);

  printf("minimum : %d\n", minimum(t, n));

  printf("6 appartient au tableau: %d\n", appartient(6, t, n));

  printf("doubler t\n");
  doubler(t, n);
  printf("Le tableau contient : \n");
  afficherTableau(t, n);

  printf("cumuler t\n");
  cumuler(t, n);
  printf("Le tableau contient : \n");
  afficherTableau(t, n);

  printf("renverser t\n");
  renverser(t, n);
  printf("Le tableau contient : \n");
  afficherTableau(t, n);


  return EXIT_SUCCESS;
}
